using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UnityEngine;

public class MapElementsProvider : MonoBehaviour
{
    public Background BackgroundPrefab;

    public Road RoadPrefab;
    public ShiftPoint ShiftPointPrefab;
    public MapChunk MapChunkPrefab;

    public BackgroundPool BPool;

    public RoadPool RPool;
    public ShiftPointPool SPool;
    public MapChunkPool MPool;
    private void Start()
    {
        BPool = new BackgroundPool(BackgroundPrefab);
        RPool = new RoadPool(RoadPrefab);
        SPool = new ShiftPointPool(ShiftPointPrefab);
        MPool = new MapChunkPool(MapChunkPrefab);
    }






}
public class MapChunkPool : SimplePool<MapChunk>
{
    public MapChunkPool(MapChunk prefab) : base(prefab)
    {

    }

}

public class ShiftPointPool : SimplePool<ShiftPoint>
{
    public ShiftPointPool(ShiftPoint prefab) : base(prefab)
    {

    }

}

public class BackgroundPool : SimplePool<Background>
{
    public BackgroundPool(Background prefab) : base(prefab)
    {

    }

}
public class RoadPool : SimplePool<Road>
{
    public RoadPool(Road prefab) : base(prefab)
    {

    }

}
